#!/usr/bin/wish

#######################################################################################################
## tkspeedtouch written by Roberto Di Stefano A.k.a e4m
## Is a simple GUI to setting up your speedtouch modem.
## www.gnu-nerd.org/tkspeedtouch written under GPL (Read License)
## LetHackles runs only on system ( whitin Tcl/Tk ), soon optimized for *BSD
##
## Author: Roberto Di Stefano A.k.a e4m
## mail:   e4m@autistici.org
## web :   www.gnu-nerd.org
## irc:    irc.azzurra.org / e4m
##
## Problems ? Read 'README` and "http://speedtouch.sourceforge.net/index.php?/docs.en.html" frist use it!
## Find a bug? Fix it or send me an e-mail, relase is a beta! (Free bugs NO WARRENTY)
## Microvawe Drivers are propriety of Alcatel(c), and Unix-Like Drivers (c) by http://speedtouch.sf.net 
#######################################################################################################



  wm title . "tkspeedtouch (tcl/tk) - by e4m"
  wm resizable . 0 0
  . configure -bg white

  image create photo intro2 -file [file join intro.gif]
  label .intro -image intro2 -bg white
  pack .intro 

 set id [exec id -u]

 if {$id != 0} {

  tk_messageBox -icon error -type ok -message "You must be root!"
  exit
 }

 tk_messageBox -icon info -type ok -message "With that wizard simple operations you can configure soon your speedtouch modem.."
 tk_messageBox -icon info -type ok -message "Phase 1: I'll check compatibility of kernel, and itegrity of pppd!"

 image create photo intro3 -file [file join logo.gif]
 label .logo -image intro3 -bg white
 pack .logo 

 puts "* Getting current kernel ver.."
 catch {exec uname -r} request0
 puts [split $request0]


if {[string match *2.4.* $request0]} {
  puts "OK good kernel version: $request0"
  label .kernel -bg white -text "OK good kernel version: $request0"
  set check "OK"
  image create photo a -file [file join passed.gif]
  label .a -image a -bg white
  pack .kernel .a 

} elseif {[string match *2.6.* $request0]} {
  puts "OK good kernel version: $request0"
  label .kernel -bg white -text "OK good kernel version: $request0"
  set check "OK"
  image create photo b -file [file join passed.gif]
  label .b -image b -bg white
  pack .kernel .b 


} elseif {[string match *2.2.* $request0]} {
  puts "! maybe driver not runs with kernel 2.2.* (try it!)"
  puts "* we suggest to upgrade *"
  label .kernel -bg white -text "maybe driver not runs with kernel 2.2.* (try it!)"
  set check "OK"
  image create photo c -file [file join maybe.gif]
  label .c -image c -bg white
  pack .kernel .c 

} else {
  puts "BAD unknow version of kernel , or too old: $request0"
  label .kernel -bg white -text "BAD unknow version of kernel , or too old: $request0"
  set check "BAD"
  image create photo d -file [file join ko.gif]
  label .d -image d -bg white
  pack .kernel .d 

}


##searching for bugged kernel..
if {[string match *2.4.5* $request0]} {
  puts "BAD current kernel version is seriously bugged in USB support!"
  puts "* we suggest to upgrade *"
  destroy .kernel
  label .kernel -bg white -text "BAD current kernel version is seriously bugged in USB support!"
  pack .kernel
  set check "BAD"
  image create photo e -file [file join ko.gif]
  label .e -image e -bg white
  pack .kernel .e 
}


##searching for support..
if {[string match *2.4.22* $request0]} {
  puts "OK oh yes, this kernel contains the speedtouch kernel module!"
  destroy .kernel
  label .kernel -bg white -text "OK oh yes, this kernel contains the speedtouch kernel module!"
  pack .kernel
  set check "OK"
  image create photo f -file [file join passed.gif]
  label .f -image f -bg white
  pack .kernel .f 

}

puts "KERNEL : $check"


 puts "* Searching for pppd.."
 catch {exec locate pppd} request

if {[string match *bin/pppd* $request]} {
  label .pppd -bg white -text "OK pppd found!"
  puts "OK pppd found!"
  set check2 "OK"
  image create photo g -file [file join passed.gif]
  label .g -image g -bg white
  pack .pppd .g 

} else {
  puts "BAD pppd not found.."
  puts "make sure your pppd was on your box"
  puts "remember.. you MUST have 'locate`"
  label .pppd -bg white -text "pppd not found"
  set check2 "BAD"
  image create photo h -file [file join ko.gif]
  label .h -image h -bg white
  pack .pppd .h  
} 



##searching for pppd bugged
 catch {exec /usr/sbin/pppd --version} request3
 puts [split $request3]


##locate pppd!

 catch {exec /sbin/pppd --version} pppdlocation1
 catch {exec /usr/bin/pppd --version} pppdlocation2
 catch {exec /usr/sbin/pppd --version} pppdlocation3



if {[string match *2.4* $request3]} {
  puts "OK ok good version of pppd"
set check2 "OK"


} elseif {[string match *2.3* $request3]} {

  destroy .pppd
  label .pppd -bg white -text "maybe bugged version of pppd (need min. 2.3.11), good work with 2.4*"
  set check2 "OK"
  image create photo i -file [file join maybe.gif]
  label .i -image i -bg white
  pack .pppd .i 
}

puts "PPPD: $check2"

if {[string match *version* $pppdlocation1]} {
  label .ppdloc -bg white -text "( pppd is located here /sbin/pppd )"
  pack .pppdloc
  puts "( pppd is located here /sbin/pppd )"

} elseif {[string match *version* $pppdlocation2]} {
  label .pppdloc -bg white -text "( pppd is located here /usr/bin/pppd )"
  pack .pppdloc
  puts "( pppd is located here /usr/bin/pppd )"

} elseif {[string match *version* $pppdlocation3]} {
  label .pppdloc -bg white -text "( pppd is located here /usr/sbin/pppd )"
  pack .pppdloc
  puts "( pppd is located here /usr/sbin/pppd )"

} else {
  label .pppdloc -bg white -text "( pppd is located here /usr/sbin/pppd )"
  pack .pppdloc
  puts "( pppd is located here /usr/sbin/pppd )"
}


if {$check == "OK"} {

  if {$check2 == "OK"} {

 image create photo two -file [file join frecc2.gif]
 button .fdx -image two -bd 2 -relief sunken -command {forward}
 pack .fdx -side right
 
  } else {

 button .exit -text "exit" -bd 2 -relief sunken -command {exit}
 pack .exit -side right
 
 }
}


 image create photo one -file [file join abo.gif]
 button .about -image one -bd 2 -relief sunken -command {about}
 pack .about -side left

proc about {} {

 toplevel .win
 wm title .win "tkspeedtouch (tcl/tk) - about"
 .win configure -bg white
  wm resizable .win 0 0

 image create photo intro4 -file [file join intro.gif]
 label .win.lab -image intro3 -bg white
 label .win.labl -image intro4 -bg white
 label .win.lab1 -text "tkspeedtouch is a simple GUI to setting up 'speedtouch` alcatel modem" -bg white
 label .win.lab2 -text "source code written and relase under GPL license by Roberto Di Stefano" -bg white
 label .win.lab3 -text "A.k.a e4m , e-mail: e4m@autistici.org , web: www.gnu-nerd.org" -bg white
 label .win.lab4 -text "SpeedTouch drivers are (c) by alcatel and http://speedtouch.sourceforge.net" -bg white
 button .win.ok -text ok -bg white -command {destroy .win}
 pack .win.lab .win.labl .win.lab1 .win.lab2 .win.lab3 .win.lab4 .win.ok

}


proc forward {} {

 toplevel .win2
 wm title .win2 "tkspeedtouch (tcl/tk) - configure (2/4)"
 .win2 configure -bg white
  wm resizable .win2 0 0


 puts "* Searching for USB in kernel.."
 catch {exec locate pppd} request
 puts [split $request]

 tk_messageBox -icon info -type ok -message "Phase 2: I'll check USB support in kernel using various utility like lspci, and i search drivers.."

 catch {exec /sbin/lspci --version} lspcilocation1
 catch {exec /usr/bin/lspci --version} lspcilocation2
 catch {exec /usr/sbin/lspci --version} lspcilocation3
 catch {exec lspci --version} lspcilocation4


if {[string match *version* $lspcilocation1]} {
  label .win2.lspciloc -bg white -text "( lspci is located here /sbin/lspci )"
  pack .win2.lspciloc
  puts "( lspci is located here /sbin/lspci )"
  image create photo a -file [file join passed.gif]
  label .win2.a -image a -bg white
  pack .win2.lspciloc .win2.a
  set check3 "OK"
  set lspci "/sbin/lspci"

} elseif {[string match *version* $lspcilocation2]} {
  label .win2.lspciloc -bg white -text "( lspci is located here /usr/bin/lspci )"
  puts "( lspci is located here /usr/bin/lspci )"
  image create photo b -file [file join passed.gif]
  label .win2.b -image b -bg white
  pack .win2.lspciloc .win2.b
  set check3 "OK"
  set lspci "/usr/bin/lspci"

} elseif {[string match *version* $lspcilocation3]} {
  label .win2.lspciloc -bg white -text "( lspci is located here /usr/sbin/lspci )"
  puts "( lspci is located here /usr/sbin/lspci )"
  set check3 "OK"
  image create photo c -file [file join passed.gif]
  label .win2.c -image c -bg white
  pack .win2.lspciloc .win2.c 
  set lspci "/usr/sbin/lspci"

} elseif {[string match *version* $lspcilocation4]} {
  label .win2.lspciloc -bg white -text "( lspci is located here lspci )"
  puts "( lspci is located here lspci )"
  set check3 "OK"
  image create photo d -file [file join passed.gif]
  label .win2.d -image d -bg white
  pack .win2.lspciloc .win2.d 
  set lspci "lspci"

} else {
  label .win2.lspciloc -bg white -text "BAD lspci not found"  
  puts "BAD pppd not found.."
  puts "make sure your lspci is on your box"
  puts "remember.. you MUST have 'locate`"
  puts "BAD lspci not found"  
  set check3 "BAD"
  image create photo e -file [file join ko.gif]
  label .win2.e -image e -bg white
  pack .win2.lspciloc .win2.e 
}


puts "LSPCI : $check3"



 catch {exec $lspci | grep USB} usb


 if {[string match *USB* $usb]} {

  puts "USB support seems to be ok"
  puts $usb
  set check4 "OK"
  label .win2.usbmsg -bg white -text "USB support seems to be ok"
  label .win2.usbmsg2 -bg white -text $usb
  image create photo usbok -file [file join passed.gif]
  label .win2.usbok -image usbok -bg white
  pack .win2.usbmsg .win2.usbok  
  pack .win2.usbmsg2


 } else {
  puts "USB support not found"
  label .snf -text "USB kernel support not found" -bg white 
  image create photo usb -file [file join ko.gif]
  label .win2.usb -image usb -bg white
  pack .snf .win2.usb 
  set check4 "BAD"
}
 puts "USB KERNEL SUPPORT: $check4"

 puts "* Searching for speedtouch drivers.."
 catch {exec whereis modem_run} request5


## modem_run pppoa2 pppoa3

if {[string match *bin/modem_run* $request5]} {
  label .win2.drivers -bg white -text "OK drivers found!"
  puts "OK drivers found!"
  set check5 "OK"
  image create photo m -file [file join passed.gif]
  label .win2.m -image m -bg white
  pack .win2.drivers .win2.m 

} else {  
  label .win2.drivers -bg white -text "BAD drivers not found!"
  puts "BAD drivers not found.."
  puts "make sure your drivers are on your box"
  puts "remember.. you MUST have 'whereis`"
  label .pppd -bg white -text "pppd not found"
  set check5 "BAD"
  image create photo n -file [file join ko.gif]
  label .win2.n -image n -bg white
  pack .win2.drivers .win2.n  
} 

 puts "DRIVERS: $check5"

if {$check3 == "OK"} {

  if {$check4 == "OK"} {

    if {$check5 == "OK"} {

   image create photo two -file [file join frecc2.gif]
   button .win2.fdx -image two -bd 2 -relief sunken -command {forward2}
   pack .win2.fdx -side right
 
  } else {

   button .exit -text "exit" -bd 2 -relief sunken -command {exit}
   pack .exit -side right
 
  }
 }
}


 image create photo logo -file [file join logo.gif]
 label .win2.logo -image logo -bg white
 label .win2.ti -text "" -bg white

 pack .win2.logo

}

proc forward2 {} {
tk_messageBox -icon info -type ok -message "Phase 3: Now i settiung up various script for pppd and configure its with appropriate drivers"
tk_messageBox -icon warning -type ok -message "If PPPOA2 will not found you can probably use PPPOA3, check it manually. if exist CHECK radiobutton 'use pppoa3' as YES in current window, next time you restart this app.!"
 
 toplevel .win3
 wm title .win3 "tkspeedtouch (tcl/tk) - configure (3/4)"
 .win3 configure -bg white
  wm resizable .win3 0 0

 set microw "/root/mgmt"

 set pppoa3 0
 label .win3.up3 -bg white -text "use pppoa3?"
 radiobutton .win3.y -text Yes -relief flat -variable pppoa3 -value 1 -bg white
 radiobutton .win3.n -text No -relief flat -variable pppoa3 -value 0 -bg white
 pack .win3.up3 .win3.y .win3.n

 label .win3.titolo2 -bg white -text "you can also use windows driver"
 label .win3.titolo3 -bg white -text "/mnt/win/windows/system/alcudsl.sys"
 label .win3.titolo4 -bg white -text ""

 label .win3.titolo -bg white -text "Type microwave's (dvrreg_lx) path:"
 entry .win3.entry -bg white -textvariable microw


 label .win3.user -bg white -text "Type your Account User:"
 entry .win3.usere -bg white -textvariable login
 label .win3.pass -bg white -text "Type your Account Password:"
 entry .win3.passe -bg white -textvariable pass

 pack .win3.user .win3.usere .win3.pass .win3.passe
 
 label .win3.dns1 -bg white -text "Type primary DNS:"
 entry .win3.dns1e -bg white -textvariable dns1
 label .win3.dns2 -bg white -text "Type secondary DNS:"
 entry .win3.dns2e -bg white -textvariable dns2

 pack .win3.dns1 .win3.dns1e .win3.dns2 .win3.dns2e

 pack .win3.titolo .win3.entry .win3.titolo4 .win3.titolo2 .win3.titolo3

 button .win3.okscr -bg white -text SpawnScripts -command {create_scripts}
 pack .win3.okscr

 pack .win3.titolo .win3.entry .win3.titolo4 .win3.titolo2 .win3.titolo3
 image create photo logo -file [file join logo.gif]
 label .win3.logo -image logo -bg white
 label .win3.ti -text "" -bg white
 pack .win3.logo

}


 proc create_scripts {} {
  global microw
  global login
  global pass
  global dns1
  global dns2
  global pppoa3


 puts "* Searching for pppoa.."


 catch {exec /sbin/pppoa2 --version} pl1
 catch {exec /usr/bin/pppoa2 --version} pl2
 catch {exec /usr/sbin/pppoa2 --version} pl3
 catch {exec /usr/local/bin/pppoa2 --version} pl4
 catch {exec /usr/local/sbin/pppoa2 --version} pl5
 catch {exec pppoa2 --version} pl6


if {[string match *version* $pl1]} {
  label .win3.pl -bg white -text "( pppoa2 is located here /sbin/pppoa2 )"
  puts "( pppoa2 is located here /sbin/pppoa2 )"
  image create photo a -file [file join passed.gif]
  label .win3.a -image a -bg white
  pack .win3.pl .win3.a
  set check7 "OK"
  set pppoal "/sbin/pppoa2"

} elseif {[string match *version* $pl2]} {
  label .win3.pl -bg white -text "( pppoa2 is located here /usr/bin/pppoa2 )"
  puts "( pppoa2 is located here /usr/bin/pppoa2 )"
  image create photo a -file [file join passed.gif]
  label .win3.a -image a -bg white
  pack .win3.pl .win3.a
  set check7 "OK"
  set pppoal "/usr/bin/pppoa2"

} elseif {[string match *version* $pl3]} {
  label .win3.pl -bg white -text "( pppoa2 is located here /usr/sbin/pppoa2 )"
  puts "( pppoa2 is located here /usr/sbin/pppoa2 )"
  image create photo a -file [file join passed.gif]
  label .win3.a -image a -bg white
  pack .win3.pl .win3.a
  set check7 "OK"
  set pppoal "/usr/sbin/pppoa2"

} elseif {[string match *version* $pl4]} {
  label .win3.pl -bg white -text "( pppoa2 is located here /usr/local/bin/pppoa2 )"
  puts "( pppoa2 is located here /usr/local/bin/pppoa2 )"
  image create photo a -file [file join passed.gif]
  label .win3.a -image a -bg white
  pack .win3.pl .win3.a
  set check7 "OK"
  set pppoal "/usr/local/bin/pppoa2"

} elseif {[string match *version* $pl5]} {
  label .win3.pl -bg white -text "( pppoa2 is located here /usr/local/sbin/pppoa2 )"
  puts "( pppoa2 is located here /usr/local/sbin/pppoa2 )"
  image create photo a -file [file join passed.gif]
  label .win3.a -image a -bg white
  pack .win3.pl .win3.a
  set check7 "OK"
  set pppoal "/usr/local/sbin/pppoa2"

} elseif {[string match *version* $pl6]} {
  label .win3.pl -bg white -text "( pppoa2 is located here pppoa2 )"
  puts "( pppoa2 is located here pppoa2 )"
  image create photo a -file [file join passed.gif]
  label .win3.a -image a -bg white
  pack .win3.pl .win3.a
  set check7 "OK"
  set pppoal "pppoa2"

} else {

  label .win3.pl -bg white -text "BAD pppoa2 not found (PROBABILY YOU CAN USE PPPOA3)"  
  puts "BAD pppoa2 not found.."
  puts "make sure your pppoa2 is on your box"
  puts "remember.. you MUST have 'whereis`"
  puts "BAD pppoa2 not found"  
  set check7 "BAD"
  image create photo e -file [file join ko.gif]
  label .win3.e -image e -bg white
  pack .win3.pl .win3.e 
  
}

  set pppoa "pty $pppoal -vpi 8 -vci 35"

if {$pppoa3 == 1} {
  tk_messageBox -icon info -type ok -message "PPPOA3 assumed as /usr/local/sbin/pppoa3 if this is wrong path. edit 5th line of /etc/ppp/peers/adsl within current correct path."
  set check7 "OK"
  set pppoa "pty /usr/local/sbin/pppoa3 -m 1 -c -vpi 8 -vci 35"
  set pppoal pppoa3

}
   puts "PPPOA : $check7"


if {$check7 == "OK"} {

   label .win3.pppoa -bg white -text "Using $pppoal"

  set idfile [open "adsl-on.sh" w]
  puts $idfile "#!/bin/sh"
  puts $idfile "/sbin/modprobe n_hdlc"
  puts $idfile "/sbin/modprobe ppp_synctty"
  puts $idfile "/usr/local/bin/modem_run -f $microw/mgmt.o -m"
  puts $idfile "/usr/sbin/pppd call adsl"
  puts $idfile "/sbin/route add default ppp0"
  close $idfile


  set idfile2 [open "adsl" w]
  puts $idfile2 "debug"
  puts $idfile2 "kdebug1"
  puts $idfile2 "noipdefault"
  puts $idfile2 "defaultroute"
  puts $idfile2  $pppoa 
  puts $idfile2 "sync"
  puts $idfile2 "user $login"
  puts $idfile2 "password $pass"
  puts $idfile2 "noauth"
  puts $idfile2 "noaccomp"
  puts $idfile2 "nopcomp"
  puts $idfile2 "noccp"
  puts $idfile2 "novj"
  puts $idfile2 "holdoff 4"
  puts $idfile2 "persist"
  puts $idfile2 "maxfail 25"
  puts $idfile2 "usepeerdns"
  close $idfile2

  set idfile3 [open "resolv.conf" w]
  puts $idfile3 "nameserver $dns1"
  puts $idfile3 "nameserver $dns2"
  close $idfile3
  
  set idfile4 [open "pap-secrets" w]
  puts $idfile4 "$login\t *\t $pass"
  close $idfile4


  set idfile5 [open "adsl-off.sh" w]
  puts $idfile5 "#!/bin/sh"
  puts $idfile5 "killall -9 pppd"
  close $idfile5

  set idfile6 [open "options" w]
  puts $idfile6 "noauth"
  puts $idfile6 "usepeerdns"
  puts $idfile6 "lock"
  puts $idfile6 "noipdefault"
  close $idfile5

  puts "Moving files..."
  
  eval exec chmod +x [glob *.sh];
  eval exec mv [glob *.sh] /root/
  eval exec mv adsl /etc/ppp/peers/
  eval exec mv options /etc/ppp/
  eval exec mv pap-secrets /etc/ppp/
  eval exec mv resolv.conf /etc/
 
 last

} else {


   button .win3.exit -text "exit" -bd 2 -relief sunken -command {exit}
   pack .win3.exit -side right
}

  puts "Last Phase 3/3..."
}


proc last {} {

 tk_messageBox -icon info -type ok -message "Phase 4: Your modem is ready to start!!"
 
 toplevel .win4
 wm title .win4 "tkspeedtouch (tcl/tk) - configure (4/4)"
 .win4 configure -bg white
  wm resizable .win4 1 1

 image create photo modem -file [file join modem.gif]
 label .win4.modem -image modem -bg white

 label .win4.titolo -text "To start connection use: ./root/adsl-on.sh" -bg white
 label .win4.titolo2 -text "To stop connection use: ./root/adsl-off.sh" -bg white
 pack .win4.modem .win4.titolo .win4.titolo2 -side left -side top

 image create photo edit -file [file join edit.gif]
 label .win4.edit -image edit -bg white

 label .win4.titolo3 -text "If you want edit chat file: /etc/ppp/peers/adsl" -bg white
 label .win4.titolo4 -text "If you want edit pap-secret file: /etc/ppp/pap-secrets" -bg white
 label .win4.titolo5 -text "DNS are in: /etc/resolv.conf" -bg white
 pack .win4.edit .win4.titolo3 .win4.titolo4 .win4.titolo5 -side right -side bottom

 
 image create photo logo -file [file join logo.gif]
 label .win4.logo -image logo -bg white
 pack .win4.logo -side bottom


}